<template>
  <div class="container">
    <h2>New Equipment</h2>
    <b-form-input
      v-model="item_id"
      placeholder="item id"
      type="number">
    </b-form-input>
    <small>in case you don't know your item id, visit <nuxt-link to="/admin/items">items</nuxt-link> </small>
    <b-form-input
      v-model="body_slot"
      placeholder="body slot"
      type="number">
    </b-form-input>
    <small>0:helmet, 1:torso, 2:legs, 3:feet, 4:accessory, 5:left_hand, 6:right_hand, 7:quiver</small>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      item_id: '',
      body_slot: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.body_slot !== '' && this.body_slot < 8 && this.item_id * (this.body_slot+1) > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        equipment: {
          item_id: this.item_id,
          body_slot: this.body_slot
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/equipment',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
